/******************************************************************************\
** Program  : RAWWORD.C                             Creation Date: 10/19/1987 **
** Compiler : Lattice C 3.2                         Last Modified: 10/19/1987 **
** TechNotes: No nested comments                                              **
**          : -n switch needed to allow for long variable names               **
**          : QuickSilver Requires the large model                            **
** Function : Remove all non alpha characters from a string. Extra Spaces are **
**          :  also removed.                                                  **
** Helper   : Richard Hendricks, RICHARD 22                                   **
**          : General Electric Co.,                                           **
**          : 1000 Western Ave., Md: 45207,                                   **
**          : Lynn, Ma.  01910                   (617) 594-9692               **
\******************************************************************************/
#include <stdio.h>                     /* Standard I/O and basic Declarations*/
#include <string.h>                    /* String Functions                   */
#include <ctype.h>                     /* IS...() type functions             */

#define TRUE   1
#define FALSE  0
#define SPACE  32

void rawword( in_str)
/*****************************************************************************\
** Function: Removes all non alpha characters from in_str and returns the    **
**           results through the same argument. The returned string is padded**
**           on the right with spaces                                        **
\*****************************************************************************/

char *in_str;          
{
int  in, work;
int  str_len;
char work_str[ 255+1 ];                   /* +1 to remind me that I accounted*/
                                          /* for the string terminator \0    */
int  store_space;                         /* Should Space be added or not    */

str_len       = strlen( in_str );
work_str[ 0 ] = '\0';
store_space   = FALSE;                         /* Start out False, to skip    */
                                               /*  over any leading spaces    */

for( in = 0, work = 0; in < str_len; in++ )
    {
    if( isalpha( in_str[ in ] ) != 0 ||        /* All letters ( upper/lower ) */
        in_str[ in ] == SPACE )                /* Space Character             */
                                               /* ISSPACE() finds white space */
       {
       if( in_str[ in ] != SPACE )             /* If a letter, add to the string*/
                                               /*  and turn off the switch      */ 
         {
         work_str[ work ] = toupper( in_str[ in ] );
         store_space = TRUE;
         work++;
         }
         else
         {
         if( store_space == TRUE )             /* If a space & it is to be added*/
                                               /*  then add it and turn off the */
                                               /*  switch                       */ 
            {
            work_str[ work ] = in_str[ in ];
            store_space = FALSE;
            work++;
            }
         }
       }
     }
work_str[ work ] = '\0';
sprintf( in_str, "%-*s", str_len, work_str );
}
/*  rawword() */
/* end-of-file                      RAWWORD.C                   end-of-file  */
